using Proto;
using Proto.Cluster;

using TestProject;

WebApplicationBuilder builder = WebApplication.CreateBuilder(args);

builder.Services.AddActorSystem();

builder.Services.AddHostedService<ActorSystemClusterHostedService>();

builder.Services.AddHostedService<SmartBulbSimulator>();

WebApplication application = builder.Build();

ILoggerFactory loggerFactory = application.Services.GetRequiredService<ILoggerFactory>();

Log.SetLoggerFactory(loggerFactory);

application.MapGet("/", () => Task.FromResult("ȳϼ, Proto.Cluster!"));

application.MapGet
(
    "/smart-bulbs/{identity}",
    async (ActorSystem actorSystem, string identity) =>
    {
        return await actorSystem
            .Cluster()
            .GetSmartBulbGrain(identity)
            .GetState(CancellationToken.None);
    }
);

application.Run();